﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esempio.MVC
{
    public partial class View2 : View
    {
        public View2()
        {
            InitializeComponent();
        }

        public Color Color
        {
            get { return Color.FromArgb(_trackBarA.Value, _trackBarR.Value, _trackBarG.Value, _trackBarB.Value); }
            set
            {
                if (value != Color)
                {
                    _trackBarA.Value = value.A;
                    _trackBarR.Value = value.R;
                    _trackBarG.Value = value.G;
                    _trackBarB.Value = value.B;
                    RefreshTextBox();
                }
            }
        }

        protected override void OnModelChanged(object sender, EventArgs e)
        {
            if (sender != Model)
                throw new ApplicationException("sender != Model");
            Color = Model.Color;
        }

        private void TrackBar_Scroll(object sender, EventArgs e)
        {
            RefreshTextBox();
            if (Controller != null)
            {
                Controller.CambiaColore(Color);
            }
        }

        private void RefreshTextBox()
        {
            _textBox.Text = Color.ToString();
        }
    }
}
