﻿using System;
using System.Drawing;

namespace Esempio.MVP
{
    public abstract class Presenter
    {
        private Model _model;

        public Model Model
        {
            get { return _model; }
            set
            {
                if (value != _model)
                {
                    if (_model != null)
                    {
                        //  Deregistrazione
                        _model.Changed -= OnModelChanged;
                    }
                    _model = value;
                    if (_model != null)
                    {
                        //  Registrazione
                        _model.Changed += OnModelChanged;
                        OnModelChanged(_model, EventArgs.Empty);
                    }
                }
            }
        }

        protected abstract void OnModelChanged(object sender, EventArgs e);
    }
}
